This document describes the current stable version of Celery (5.6). For development docs, go here.

# `celery.platforms`

Platforms.

Utilities dealing with platform specifics: signals, daemonization, users, groups, and so on.

class celery.platforms.DaemonContext(pidfile=None, workdir=None, umask=None, fake=False, after_chdir=None, after_forkers=True, **kwargs)

  Context manager daemonizing the process.

  close(*args)
  open()
  redirect_to_null(fd)

exception celery.platforms.LockFailed

  Raised if a PID lock can’t be acquired.

class celery.platforms.Pidfile(path)

  Pidfile.

  This is the type returned by `create_pidlock()`.

  See also

  Best practice is to not use this directly but rather use the `create_pidlock()` function instead: more convenient and also removes stale pidfiles (when the process holding the lock is no longer running).

  acquire()

    Acquire lock.

  is_locked()

    Return true if the pid lock exists.

  path = None

    Path to the pid lock file.

  read_pid()

    Read and return the current pid.

  release(*args)

    Release lock.

  remove()

    Remove the lock.

  remove_if_stale()

    Remove the lock if the process isn’t running.

    I.e. process does not respond to signal.

  write_pid()

celery.platforms.close_open_fds(keep=None)

celery.platforms.create_pidlock(pidfile)

  Create and verify pidfile.

  If the pidfile already exists the program exits with an error message, however if the process it refers to isn’t running anymore, the pidfile is deleted and the program continues.

  This function will automatically install an `atexit` handler to release the lock at exit, you can skip this by calling `_create_pidlock()` instead.

  Returns:

    used to manage the lock.

  Return type:

    Pidfile

  Example

      >>> pidlock = create_pidlock('/var/run/app.pid')

celery.platforms.detached(logfile=None, pidfile=None, uid=None, gid=None, umask=0, workdir=None, fake=False, **opts)

  Detach the current process in the background (daemonize).

  Parameters:

    - logfile (str) – Optional log file. The ability to write to this file will be verified before the process is detached.

    - pidfile (str) – Optional pid file. The pidfile won’t be created, as this is the responsibility of the child. But the process will exit if the pid lock exists and the pid written is still running.

    - uid (int, str) – Optional user id or user name to change effective privileges to.

    - gid (int, str) – Optional group id or group name to change effective privileges to.

    - umask (str, int) – Optional umask that’ll be effective in the child process.

    - workdir (str) – Optional new working directory.

    - fake (bool) – Don’t actually detach, intended for debugging purposes.

    - **opts (Any) – Ignored.

  Example

      >>> from celery.platforms import detached, create_pidlock
      >>> with detached(
      ...           logfile='/var/log/app.log',
      ...           pidfile='/var/run/app.pid',
      ...           uid='nobody'):
      ... # Now in detached child process with effective user set to nobody,
      ... # and we know that our logfile can be written to, and that
      ... # the pidfile isn't locked.
      ... pidlock = create_pidlock('/var/run/app.pid')
      ...
      ... # Run the program
      ... program.run(logfile='/var/log/app.log')

celery.platforms.fd_by_path(paths)

  Return a list of file descriptors.

  This method returns list of file descriptors corresponding to file paths passed in paths variable.

  Parameters:

    paths – List[str]: List of file paths.

  Returns:

    List of file descriptors.

  Return type:

    List[int]

  Example

      >>> keep = fd_by_path(['/dev/urandom', '/my/precious/'])

celery.platforms.get_errno_name(n)

  Get errno for string (e.g., `ENOENT`).

celery.platforms.get_fdmax(default=None)

  Return the maximum number of open file descriptors on this system.

  Keyword Arguments:

    default – Value returned if there’s no file descriptor limit.

celery.platforms.ignore_errno(*errnos, **kwargs)

  Context manager to ignore specific POSIX error codes.

  Takes a list of error codes to ignore: this can be either the name of the code, or the code integer itself:

      >>> with ignore_errno('ENOENT'):
      ...     with open('foo', 'r') as fh:
      ...         return fh.read()

      >>> with ignore_errno(errno.ENOENT, errno.EPERM):
      ...    pass

  Parameters:

    types (Tuple[Exception]) – A tuple of exceptions to ignore (when the errno matches). Defaults to `Exception`.

celery.platforms.initgroups(uid, gid)

  Init process group permissions.

  Compat version of `os.initgroups()` that was first added to Python 2.7.

celery.platforms.isatty(fh)

  Return true if the process has a controlling terminal.

celery.platforms.maybe_drop_privileges(uid=None, gid=None)

  Change process privileges to new user/group.

  If UID and GID is specified, the real user/group is changed.

  If only UID is specified, the real user is changed, and the group is changed to the users primary group.

  If only GID is specified, only the group is changed.

celery.platforms.parse_gid(gid)

  Parse group id.

  Parameters:

    gid (str, int) – Actual gid, or the name of a group.

  Returns:

    The actual gid of the group.

  Return type:

    int

celery.platforms.parse_uid(uid)

  Parse user id.

  Parameters:

    uid (str, int) – Actual uid, or the username of a user.

  Returns:

    The actual uid.

  Return type:

    int

celery.platforms.pyimplementation()

  Return string identifying the current Python implementation.

celery.platforms.set_mp_process_title(progname, info=None, hostname=None)

  Set the ps name from the current process name.

  Only works if https://pypi.org/project/setproctitle/ is installed.

celery.platforms.set_process_title(progname, info=None)

  Set the ps name for the currently running process.

  Only works if https://pypi.org/project/setproctitle/ is installed.

celery.platforms.setgid(gid)

  Version of `os.setgid()` supporting group names.

celery.platforms.setgroups(groups)

  Set active groups from a list of group ids.

celery.platforms.setuid(uid)

  Version of `os.setuid()` supporting usernames.

celery.platforms.signal_name(signum)

  Return name of signal from signal number.